/* ----------------------------------------------------------------------- */
/*         Fernando Berzal Galiano       ETS Ingeniera Informtica        */
/* ----------------------------------------------------------------------- */
/*               Acceso secuencial a las fichas de una tabla               */
/* ----------------------------------------------------------------------- */

#include <stdio.h>

#include "DB.H"

#ifndef __DB_SECUENCIAL__
#define __DB_SECUENCIAL__


typedef struct Acceso {
			DataBase   bd;
			long       numero;
			int        NumFicheros;
			FILE     **f;
		      };

typedef struct Acceso *Acceso;



Acceso InicializaAccesoSecuencial (DataBase BD);


Ficha ObtieneSiguienteFicha (Acceso a);


void FinalizaAccesoSecuencial (Acceso *a);


#endif