/*------------------------------------------------------------------------*/
/*              Implementacin de funciones de comparacin                */
/*------------------------------------------------------------------------*/
/*                        Fernando Berzal Galiano                         */
/*                     E.T.S. Ingeniera Informtica                      */
/*------------------------------------------------------------------------*/

#include <string.h>

#include "FB_CMP.H"
#include "FB_STR.H"

/* ---------------------------------------------------------------------- */

int CmpPtr (void *p1, void *p2, int offset)
{
  if (p1==p2)
     return 0;
  else
     return 1;
}

/* ---------------------------------------------------------------------- */

int CmpByte (void *p1, void *p2, int offset)
{
  byte b1 = *((unsigned char *)((char*)p1+offset));
  byte b2 = *((unsigned char *)((char*)p2+offset));

  if (b1>b2)
     return 1;
  else if (b1==b2)
     return 0;
  else
     return -1;
}

/* ---------------------------------------------------------------------- */

int CmpShort (void *p1, void *p2, int offset)
{
  short i1 = *((short *)((char*)p1+offset));
  short i2 = *((short *)((char*)p2+offset));

  if (i1>i2)
     return 1;
  else if (i1==i2)
     return 0;
  else
     return -1;
}

/* ---------------------------------------------------------------------- */

int CmpInt (void *p1, void *p2, int offset)
{
  int i1 = *((int *)((char*)p1+offset));
  int i2 = *((int *)((char*)p2+offset));

  if (i1>i2)
     return 1;
  else if (i1==i2)
     return 0;
  else
     return -1;
}

/*------------------------------------------------------------------------*/

int CmpLong (void *p1, void *p2, int offset)
{
  long int l1 = *((long int *)((char*)p1+offset));
  long int l2 = *((long int *)((char*)p2+offset));

  if (l1>l2)
     return 1;
  else if (l1==l2)
     return 0;
  else
     return -1;
}

/*------------------------------------------------------------------------*/

int CmpFloat (void *p1, void *p2, int offset)
{
  float f1 = *((float *)((char*)p1+offset));
  float f2 = *((float *)((char*)p2+offset));

  if (f1>f2)
     return 1;
  else if (f1==f2)
     return 0;
  else
     return -1;
}

/*------------------------------------------------------------------------*/

int CmpDouble (void *p1, void *p2, int offset)
{
  double d1 = *((double *)((char*)p1+offset));
  double d2 = *((double *)((char*)p2+offset));

  if (d1>d2)
     return 1;
  else if (d1==d2)
     return 0;
  else
     return -1;
}

/*------------------------------------------------------------------------*/

int CmpChar (void *p1, void *p2, int offset)
{
  char c1 = *((char*)p1+offset);
  char c2 = *((char*)p2+offset);

  if (c1>c2)
     return 1;
  else if (c1==c2)
     return 0;
  else
     return -1;
}

/*------------------------------------------------------------------------*/

int CmpString (void *p1, void *p2, int offset)
{
  char *s1 = ((char*)p1+offset);
  char *s2 = ((char*)p2+offset);

  return (strcmp(s1,s2));
}

/*------------------------------------------------------------------------*/

int CmpCadena (void *p1, void *p2, int offset)  
{
  return ( CadCmp( (unsigned char*)p1+offset, (unsigned char*)p2+offset ) );
}

/*------------------------------------------------------------------------*/
